Bug 592961 - ext3: fsync() does not flush disk caches
Summary: ext3: fsync() does not flush disk caches
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel   
(Show other bugs)
Version: 5.4
Hardware: All
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Eric Sandeen
QA Contact: Igor Zhang
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-05-17 13:36 UTC by Andreas Luik
Modified: 2011-01-13 21:32 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-13 21:32:20 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:0017 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 5.6 kernel security and bug fix update 2011-01-13 10:37:42 UTC

Description Andreas Luik 2010-05-17 13:36:49 UTC
Description of problem:

fsync() on a ext3 filesystem does not flush disk caches.  This influences
data consistency, especially for database system like MySQL and PostgreSQL.
This bug has been fixed in kernel patch 2.6.31 via

commit 56fcad29d4b3cbcbb2ed47a9d3ceca3f57175417
Author: Jan Kara <jack@suse.cz>
Date:   Tue Sep 8 14:59:42 2009 +0200

    ext3: Flush disk caches on fsync when needed
    
    In case we fsync() a file and inode is not dirty, we don't force a transaction
    to disk and hence don't flush disk caches. Thus file data could be just in disk
    caches and not on persistent storage. Fix the problem by flushing disk caches
    if we didn't force a transaction commit.


It would be great if this important fix could be integrated into the
RHEL 5.x kernel line (2.6.18) and made available in the next kernel
errata.

Kind regards,
Andreas Luik

Comment 1 Eric Sandeen 2010-05-17 13:53:53 UTC
Agreed, we should probably have this.

Note that the behavior is only in effect if barriers are turned on, which is still not the default upstream or in rhel5.

-Eric

Comment 2 RHEL Product and Program Management 2010-05-20 12:49:38 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 7 Jarod Wilson 2010-09-10 21:39:51 UTC
in kernel-2.6.18-219.el5
You can download this test kernel from http://people.redhat.com/jwilson/el5

Detailed testing feedback is always welcomed.

Comment 11 errata-xmlrpc 2011-01-13 21:32:20 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2011-0017.html


Note You need to log in before you can comment on or make changes to this bug.